// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _GTKMM_CELLAREACONTEXT_H
#define _GTKMM_CELLAREACONTEXT_H


#include <glibmm.h>

/* Copyright (C) 2010 The gtkmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <glibmm/object.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GtkCellAreaContext GtkCellAreaContext;
typedef struct _GtkCellAreaContextClass GtkCellAreaContextClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gtk
{ class CellAreaContext_Class; } // namespace Gtk
namespace Gtk
{

class CellArea;

/** A class representing an adjustable bounded value.
 *
 * The Gtk::CellAreaContext object represents a value which has an associated
 * lower and upper bound, together with step and page increments, and a page
 * size.  It is used within several gtkmm widgets, including
 * Gtk::SpinButton, Gtk::Viewport, and Gtk::Range (which is a base class for
 * Gtk::HScrollbar, Gtk::VScrollbar, Gtk::HScale, and Gtk::VScale).
 *
 * The Gtk::CellAreaContext object does not update the value itself. Instead it
 * is left up to the owner of the Gtk::CellAreaContext to control the value.
 *
 * The owner of the Gtk::CellAreaContext typically calls the value_changed() and
 * changed() functions after changing the value and its bounds. This results
 * in the emission of the "value_changed" or "changed" signal respectively.
 *
 */

class CellAreaContext : public Glib::Object
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef CellAreaContext CppObjectType;
  typedef CellAreaContext_Class CppClassType;
  typedef GtkCellAreaContext BaseObjectType;
  typedef GtkCellAreaContextClass BaseClassType;

private:  friend class CellAreaContext_Class;
  static CppClassType cellareacontext_class_;

private:
  // noncopyable
  CellAreaContext(const CellAreaContext&);
  CellAreaContext& operator=(const CellAreaContext&);

protected:
  explicit CellAreaContext(const Glib::ConstructParams& construct_params);
  explicit CellAreaContext(GtkCellAreaContext* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~CellAreaContext();

#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;


  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  GtkCellAreaContext*       gobj()       { return reinterpret_cast<GtkCellAreaContext*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const GtkCellAreaContext* gobj() const { return reinterpret_cast<GtkCellAreaContext*>(gobject_); }

  ///Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
  GtkCellAreaContext* gobj_copy();

private:

public:


protected:
 
public:

  
  Glib::RefPtr<CellArea> get_area();
  
  Glib::RefPtr<const CellArea> get_area() const;
  
  
  void allocate(int width, int height);
  
  void reset();

  
  void get_preferred_width(int& minimum_width, int& natural_width) const;
  
  void get_preferred_height(int& minimum_height, int& natural_height) const;
  
  void get_preferred_height_for_width(int width, int& minimum_height, int& natural_height) const;
  
  void get_preferred_width_for_height(int height, int& minimum_width, int& natural_width) const;
                                                                   
  
  void get_allocation(int& width, int& height) const;

  
  void push_preferred_width(int minimum_width, int natural_width);
  
  void push_preferred_height(int minimum_height, int natural_height);
 

public:

public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::


};

} /* namespace Gtk */


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Gtk::CellAreaContext
   */
  Glib::RefPtr<Gtk::CellAreaContext> wrap(GtkCellAreaContext* object, bool take_copy = false);
}


#endif /* _GTKMM_CELLAREACONTEXT_H */

